package computercomposer.view;

import computercomposer.controller.Controller;
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 * This class is the graphic interface
 * @author Pol Girbal i Jornet
 */
public class ComputerComposer extends javax.swing.JFrame {
    private Controller ctrl;
    private String name;
    private boolean major;
    private String pitch;
    private String form;
    private String inst;
    private String bars;
    private String timesig;
    private String tempo;
    
    /**
     * Creates new form ComputerComposer
     */
    public ComputerComposer() {
        major = true;
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        rbg_tonality = new javax.swing.ButtonGroup();
        file = new javax.swing.JFileChooser();
        l_name = new javax.swing.JLabel();
        t_name = new javax.swing.JTextField();
        l_instrument = new javax.swing.JLabel();
        cb_instrument = new javax.swing.JComboBox<>();
        l_tonality = new javax.swing.JLabel();
        cb_tonality = new javax.swing.JComboBox<>();
        rb_major = new javax.swing.JRadioButton();
        rb_minor = new javax.swing.JRadioButton();
        l_form = new javax.swing.JLabel();
        cb_form = new javax.swing.JComboBox<>();
        l_barsphrase = new javax.swing.JLabel();
        cb_barsphrase = new javax.swing.JComboBox<>();
        l_timesignature = new javax.swing.JLabel();
        cb_timesignature = new javax.swing.JComboBox<>();
        l_tempo = new javax.swing.JLabel();
        cb_tempo = new javax.swing.JComboBox<>();
        btn_compose = new javax.swing.JButton();
        btn_save = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        mainMenu = new javax.swing.JMenuBar();
        m_file = new javax.swing.JMenu();
        mi_compose = new javax.swing.JMenuItem();
        mi_save = new javax.swing.JMenuItem();
        m_help = new javax.swing.JMenu();
        mi_about = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Composició algorísmica");
        setBackground(new java.awt.Color(192, 222, 199));
        setResizable(false);

        l_name.setText("Nom: ");
        l_name.setToolTipText("Introdueix el títol de la composició");

        t_name.setText("Títol");

        l_instrument.setText("Instrument: ");
        l_instrument.setToolTipText("Selecciona l'instrument");

        cb_instrument.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Piano", "Guitarra", "Violí", "Clarinet" }));

        l_tonality.setText("Tonalitat: ");
        l_tonality.setToolTipText("Selecciona la tonalitat de la composició. ");

        cb_tonality.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Do", "Do #", "Re b", "Re", "Re #", "Mi b", "Mi", "Fa", "Fa #", "Sol b", "Sol", "Sol #", "La b", "La", "La #", "Si", "Si b" }));

        rbg_tonality.add(rb_major);
        rb_major.setSelected(true);
        rb_major.setText("Major");
        rb_major.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rb_majorActionPerformed(evt);
            }
        });

        rbg_tonality.add(rb_minor);
        rb_minor.setText("Menor");
        rb_minor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rb_minorActionPerformed(evt);
            }
        });

        l_form.setText("Forma: ");
        l_form.setToolTipText("Selecciona l'estructura de la composició. Cada lletra és una frase.");

        cb_form.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "A", "AA", "AB", "ABA", "AABA", "AABB", "ABAA", "ABAB", "ABBA", "ABCA", "ABACA" }));

        l_barsphrase.setText("Compassos/Frase: ");
        l_barsphrase.setToolTipText("Selecciona el nombre de compassos que ha de tenir cada frase. Exemple: Si la forma és AB, i se selecciona 8, la frase A tindrà 8 compassos i la B en tindrà 8 més.");

        cb_barsphrase.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "4", "8", "16" }));

        l_timesignature.setText("Compàs: ");
        l_timesignature.setToolTipText("Selecciona el compàs de la composició. ");

        cb_timesignature.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "2 / 4", "3 / 4", "4 / 4" }));

        l_tempo.setText("Tempo: ");
        l_tempo.setToolTipText("Selecciona el tempo de la composició. Largo és el més lent i Allegro el més ràpid.");

        cb_tempo.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Largo", "Adagio", "Andante", "Moderato", "Allegretto", "Allegro" }));

        btn_compose.setText("Compondre!");
        btn_compose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_composeActionPerformed(evt);
            }
        });

        btn_save.setText("Desar");
        btn_save.setEnabled(false);
        btn_save.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_saveActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Arial", 1, 24)); // NOI18N
        jLabel1.setText("Composició algorísmica");

        m_file.setText("Fitxer");

        mi_compose.setText("Compondre");
        mi_compose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mi_composeActionPerformed(evt);
            }
        });
        m_file.add(mi_compose);

        mi_save.setText("Desar");
        mi_save.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mi_saveActionPerformed(evt);
            }
        });
        m_file.add(mi_save);

        mainMenu.add(m_file);

        m_help.setText("Ajuda");

        mi_about.setText("Sobre l'aplicació");
        mi_about.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mi_aboutActionPerformed(evt);
            }
        });
        m_help.add(mi_about);

        mainMenu.add(m_help);

        setJMenuBar(mainMenu);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(30, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(l_name)
                            .addComponent(l_instrument)
                            .addComponent(l_form))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(t_name, javax.swing.GroupLayout.PREFERRED_SIZE, 194, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(cb_instrument, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(cb_form, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(59, 59, 59)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(l_barsphrase)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(cb_barsphrase, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(l_tonality)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(cb_tonality, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(rb_major)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(rb_minor))
                                    .addGroup(layout.createSequentialGroup()
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addGroup(layout.createSequentialGroup()
                                                .addComponent(l_tempo)
                                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                                .addComponent(cb_tempo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                            .addGroup(layout.createSequentialGroup()
                                                .addGap(51, 51, 51)
                                                .addComponent(btn_compose)))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(btn_save))))))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(l_timesignature)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(cb_timesignature, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(19, 19, 19))
            .addGroup(layout.createSequentialGroup()
                .addGap(97, 97, 97)
                .addComponent(jLabel1)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(22, 22, 22)
                .addComponent(jLabel1)
                .addGap(39, 39, 39)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(l_name)
                    .addComponent(t_name, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(l_instrument)
                    .addComponent(cb_instrument, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(l_tonality)
                    .addComponent(cb_tonality, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(rb_major)
                    .addComponent(rb_minor))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(l_form)
                    .addComponent(cb_form, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(l_barsphrase)
                    .addComponent(cb_barsphrase, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(l_timesignature)
                    .addComponent(cb_timesignature, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(l_tempo)
                    .addComponent(cb_tempo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btn_compose)
                    .addComponent(btn_save))
                .addContainerGap(71, Short.MAX_VALUE))
        );

        l_instrument.getAccessibleContext().setAccessibleDescription("");
        l_tonality.getAccessibleContext().setAccessibleDescription("");
        l_form.getAccessibleContext().setAccessibleDescription("");
        l_barsphrase.getAccessibleContext().setAccessibleDescription("");
        l_timesignature.getAccessibleContext().setAccessibleDescription("");
        l_tempo.getAccessibleContext().setAccessibleDescription("");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void rb_majorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rb_majorActionPerformed
        major = rb_major.isSelected();
    }//GEN-LAST:event_rb_majorActionPerformed

    private void rb_minorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rb_minorActionPerformed
        major = !rb_minor.isSelected();
    }//GEN-LAST:event_rb_minorActionPerformed

    private void btn_composeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_composeActionPerformed
        composeButton();
    }//GEN-LAST:event_btn_composeActionPerformed

    private void btn_saveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_saveActionPerformed
        saveButton();
    }//GEN-LAST:event_btn_saveActionPerformed

    private void mi_composeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mi_composeActionPerformed
        composeButton();
    }//GEN-LAST:event_mi_composeActionPerformed

    private void mi_saveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mi_saveActionPerformed
        saveButton();
    }//GEN-LAST:event_mi_saveActionPerformed

    private void mi_aboutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mi_aboutActionPerformed
        JOptionPane.showMessageDialog(rootPane,"Aquesta aplicació és un generador de melodies. \nSitua el cursor sobre un element per saber-ne la funció.\n\nAutor: Pol Girbal i Jornet.","Sobre l'aplicació",JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_mi_aboutActionPerformed

    /**
     * This is the main
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ComputerComposer.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ComputerComposer.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ComputerComposer.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ComputerComposer.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new ComputerComposer().setVisible(true);
            }
        });
    }
    
    /**
     * A method that shows a save dialog and gets the path file
     */
    private void saveButton() {
        file.setSelectedFile(new File(name+".mid"));
        if(file.showSaveDialog(null)==JFileChooser.APPROVE_OPTION) {
            File f;
            f = file.getSelectedFile();
            ctrl.saveFile(f);
        }
    }
    
    /**
     * A method that gets all the parameters to compose
     */
    private void composeButton() {
        if(t_name!=null) name = t_name.getText();
        pitch = cb_tonality.getSelectedItem().toString();
        form = cb_form.getSelectedItem().toString();
        inst = cb_instrument.getSelectedItem().toString();
        bars = cb_barsphrase.getSelectedItem().toString();
        timesig = cb_timesignature.getSelectedItem().toString();
        tempo = cb_tempo.getSelectedItem().toString();
        ctrl = new Controller(name,major,pitch,form,inst,bars,timesig,tempo);
        ctrl.compose();
        btn_save.setEnabled(true);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_compose;
    private javax.swing.JButton btn_save;
    private javax.swing.JComboBox<String> cb_barsphrase;
    private javax.swing.JComboBox<String> cb_form;
    private javax.swing.JComboBox<String> cb_instrument;
    private javax.swing.JComboBox<String> cb_tempo;
    private javax.swing.JComboBox<String> cb_timesignature;
    private javax.swing.JComboBox<String> cb_tonality;
    private javax.swing.JFileChooser file;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel l_barsphrase;
    private javax.swing.JLabel l_form;
    private javax.swing.JLabel l_instrument;
    private javax.swing.JLabel l_name;
    private javax.swing.JLabel l_tempo;
    private javax.swing.JLabel l_timesignature;
    private javax.swing.JLabel l_tonality;
    private javax.swing.JMenu m_file;
    private javax.swing.JMenu m_help;
    private javax.swing.JMenuBar mainMenu;
    private javax.swing.JMenuItem mi_about;
    private javax.swing.JMenuItem mi_compose;
    private javax.swing.JMenuItem mi_save;
    private javax.swing.JRadioButton rb_major;
    private javax.swing.JRadioButton rb_minor;
    private javax.swing.ButtonGroup rbg_tonality;
    private javax.swing.JTextField t_name;
    // End of variables declaration//GEN-END:variables
}